/**
 * Distractor
 * Powered by Knowbi.com
 * May-14-2012
 * @param Object que contiene{
 * 		@param id Id de la capa velo de fondo del distractor
 * 		@param tiempoEntrada Tiempo en milisegundos de aparicion del distractor
 * 		@param tiempoSalida Tiempo en milisegundos de salida del distractor
 * 		@param minOpacity Opacidad final del distractor
 * 		@param size Tamaño de la imagen del distractor[big, small]
 * 		@param css Objeto de estilos del distractor
 * 		@param textoEspera Texto que va debajo de la imagen
 * }
 */
jQuery.fn.distractorFun=function(options){
	var $this=this;
	var container=$(this);
	var defaults={
			id:'distractor_'+new Date().getTime(),
			tiempoEntrada:200,
			tiempoSalida:200,
			minOpacity:.85,
			size:'big',
			css:{'z-index':10000},
			'baseImg':'',
			textoEspera:'Un momento por favor...'
	};
	var options=$.extend(defaults, options);
        if(options.baseImg=='') options.baseImg='images/loading'
	if($('#'+options.id).lenght) options.id+=new Date().getTime();
	var _tagName=container.get(0).tagName.toLowerCase();
	var isVisible=false;
	var srcImage=(options.size=='small')?'small.gif':'big.gif';
	srcImage=options.baseImg+srcImage;
	var distractorCapa=$('<div class="distractor" id="'+options.id+'_capa" />');
		
	
	var distractorImg=$('<img id="'+options.id+'_img" src="'+srcImage+'" border="0" alt="" />');
	distractorCapa.css({
		'position':_tagName=='body'?'fixed':'absolute',
		'display':'none',
		'opacity':0,
		'z-index':10001,
		'text-align':'center'
	});
	var velo=container.Velo(options);
	distractorCapa.append(distractorImg);
	var distractorTexto=$('<div class="texto">'+options.textoEspera+'</div>');
	distractorCapa.append(distractorTexto);
	$(container).append(distractorCapa);
	//jQuery(window).on('resize',resize);
	/**
	 * Muestra el distractor y lanza el evento show
	 */
	$this.show=function(txt){
		if(txt!=undefined && txt!='') distractorTexto.html(txt);
		isVisible=true;
		distractorCapa.css('display','block');
		distractorCapa.css({
			'left':container.position().left+container.width()/2-distractorCapa.width()/2,
			'top':container.position().top+container.height()/2-distractorCapa.height()
		});
		velo.show();
		distractorCapa.stop().fadeTo(options.tiempoEntrada,1);
		$this.bind('show');
	};
	/**
	 * Oculta el distractor y lanza el evento hide
	 */
	$this.hide=function(){
		isVisible=false;
		velo.hide();
		distractorCapa.stop().fadeOut(options.tiempoSalida);
		$this.bind('hide');
	};
	/**
	 * (Evento) Centra la imagen en pantalla
	 */
	function resize(){
		var _centrar={
				'left':container.position().left+container.width()/2-distractorCapa.width()/2,
				'top':container.position().top+container.height()/2-distractorCapa.height()
		};
		if(isVisible) distractorCapa.stop().animate(_centrar,500);
		else distractorCapa.css(_centrar);
	}
	return this;
};


/**
 * Velo
 * May-17-2012
 * @param Object que contiene{
 * 		@param id Id de la capa velo de fondo del distractor
 * 		@param tiempoEntrada Tiempo en milisegundos de aparicion del distractor
 * 		@param tiempoSalida Tiempo en milisegundos de salida del distractor
 * 		@param minOpacity Opacidad final del distractor
 * 		@param css Objeto de estilos del Velo
 * }
 */
jQuery.fn.Velo=function(options){
	var $this=this;
	var container=$(this);
	var defaults={
		id:'velo_',
		tiempoEntrada:200,
		tiempoSalida:200,
		minOpacity:.85,
		css:{'z-index':10000}
	};
	var options=$.extend(defaults, options);
	var _tagName=container.get(0).tagName.toLowerCase();
	if(options.id=='velo_') options.id+=new Date().getTime();
	else options.id='velo_'+options.id;
	if($('#'+options.id).length) options.id+='_'+new Date().getTime();
	var velo=$('<div id="'+options.id+'" />');
	velo.css({
		'display':'none',
		'opacity':0,
		'position':_tagName=='body'?'fixed':'absolute',
		'width':_tagName=='body'?'100%':container.outerWidth(1),
		'height':_tagName=='body'?'100%':container.outerHeight(1),
        'top':container.position().top,
		'left':container.position().left,
		'background':'#fff'
	});
	velo.css(options.css);
    
        
    //------------------------------------------    
    var srcImage=(options.size=='small')?'small.gif':'big.gif';
	srcImage=options.baseImg+srcImage;
    
	var distractorCapa=$('<div class="distractor" id="'+options.id+'_capa" />');
			
	var distractorImg=$('<img id="'+options.id+'_img" src="'+srcImage+'" border="0" alt="" />');
	distractorCapa.css({
		//'position':_tagName=='body'?'fixed':'absolute',
		//'display':'none',
		//'opacity':0,
		//'z-index':10001,        
		'text-align':'center',        
        'padding-top': '250px'
	});	
	distractorCapa.append(distractorImg);
	var distractorTexto=$('<div class="texto">'+options.textoEspera+'</div>');
	distractorCapa.append(distractorTexto);
    velo.append(distractorCapa);
    //----------------------------------------
    
    
	$(container).append(velo);
	$this.show=function(){
		if(_tagName!='body'){
			velo.css({
				'width':container.outerWidth(1),
				'height':container.outerHeight(1),
				'top':container.position().top,
				'left':container.position().left
			});
		}
		velo.stop().fadeTo(options.tiempoEntrada,options.minOpacity);
	};
	$this.hide=function(){
		velo.stop().fadeOut(options.tiempoSalida);
	};
	return this;
};