<?php

/**
 * Mail.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * Mail.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class Mail
{

    /**
     * Constructor de la clase
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2013 INGENEO S.A.S.     
     * @access public     
     */
    public function __construct()
    {
        
    }

    /**
     * Funcion desctructora 
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2013 INGENEO S.A.S. 
     * @access public     
     */
    public function __destruct()
    {
        
    }

    /**
     * Metodo para el envio de correo
     * 
     * @param string $email   Correo destino
     * @param string $message Mensaje
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2013 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function sendMail($arrayEmail, $message, $subject = null)
    {
        $config = (array) Yii::app()->params['configMail'];        
        $error = false;
        $errorMail = '';

        if(!count($arrayEmail) > 0) {
            $error = true;
            $errorMail = 'no se configuro las cuentas de correo';
        }
        if(!isset($config['smtp']) || empty($config['smtp'])) {
            $error = true;
            $errorMail = 'smpt nulo, verifique la configuracion';
        } else {
            $smtp = $config['smtp'];
        }
        if(!isset($config['username']) || empty($config['username'])) {
            $error = true;
            $errorMail = 'usename nulo, verifique la configuracion';
        } else {
            $username = $config['username'];
        }
        if(!isset($config['password']) || empty($config['password'])) {
            $error = true;
            $errorMail = 'password nulo, verifique la configuracion';
        } else {
            $password = $config['password'];
        }


        $msgSubject = (!empty($subject)) ? $subject : 'B2B - Información pedido';

        if($error) {
            Yii::log(__FILE__ . ':' . __LINE__ . 'Error al enviar el correo : '
                . $errorMail, CLogger::LEVEL_ERROR, 'b2b.mail');
            return false;
        }

        Yii::import('application.extensions.phpmailer.JPhpMailer');
        $mail = new JPhpMailer;
        $mail->IsSMTP();
        $mail->Host = $smtp;
        $mail->SMTPSecure = 'ssl';
        $mail->Port = 465;
		//$mail->Port = 26;
	    $mail->SMTPDebug = 2;
        $mail->SMTPAuth = true;
		//$mail->SMTPSecure = true;
        $mail->Username = $username;
        $mail->Password = $password;
        $mail->SetFrom($username, $username);

        foreach($arrayEmail as $value) {
            if(!empty($value))
            $mail->AddAddress($value, $value);
        }

        
//          $mail->AddAddress($email, $email);
//          $mail->AddAddress($emailAllow, $emailAllow);
//          $mail->AddAddress(Yii::app()->params['adminEmail'],
//          Yii::app()->params['adminEmail']);
//          $mail->AddAddress(Yii::app()->params['asesorEmail'],
//          Yii::app()->params['asesorEmail']);
         
        $mail->Subject = $msgSubject;
        $mail->AltBody = $msgSubject;
        $mail->IsHTML(true);
        $mail->CharSet = "UTF-8";
        //$mail->ConfirmReadingTo = $correoConfirmacion;
        //$mail->MsgHTML($message);
        $mail->Body = $message;
        
        ob_start();
        $mail->send();
        $errorMail = ob_get_contents();
        ob_end_clean();
        if(trim($errorMail) === "" || $error === FALSE) {
            Yii::log(__FILE__ . ':' . __LINE__ . 'Error al enviar el correo : ' . $errorMail,
                CLogger::LEVEL_ERROR, 'b2b.mail');
        } else {
            return TRUE;
        }
        $mail->ClearAddresses();
        $mail->ClearAttachments();
        return false;
    }

}

?>
