<?php

/**
 * WsSiesa.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * WsSiesa.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class WsSiesa
{

    /**
     * Constructor de la clase
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S.     
     * @access public     
     */
    public function __construct()
    {
        
    }

    /**
     * Funcion desctructora 
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S. 
     * @access public     
     */
    public function __destruct()
    {
        
    }

    /**
     * Funccion para enviar el 
     * pedido al ARP de Siesa utilizando 
     * el consumo de servicio web
     * 
     * @param Order $model Modelo del pedido
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function sendOrderSiesa($model, $assignPrice = false)
    {
        try {
            if(!empty($model) && is_object($model)) {
				//Seguimiento a consumo ws -------------------------------------------------
				$sql = "INSERT INTO time_wait_ws (data, system, action, datetime_init) 
				VALUES ('".$model->ord_id."', 'b2b', 'ws', '".date('Y-m-d H:i:s')."');";
				Yii::app()->db->createCommand($sql)->execute();
				// --------------------------------------------------------------------------
                $factoryOrder = new FactoryOrder();
                $arrayXml = $factoryOrder->createOrder($model->ord_id, $model, $assignPrice); 
                $error = true;
				
                if(count($arrayXml) > 0) {
                    foreach ($arrayXml as $xml) {
                        $webServices = new WebServices;
                        $method = 'ImportarXML';
                        $url = Yii::app()->params['paramsWs']['urlWs'];
                        $params = array('pvstrDatos' => $xml, 'printTipoError' => 0);
                        if($webServices->executeMethodWs($method, $url, $params)) {
                            $response = $webServices->response;
                            if(isset($response->printTipoError)
                                && $response->printTipoError === 0) {
                                //--------------------------------------------------
//                                Yii::log(__FILE__ . ':' . __LINE__ . ':'
//                                    . __FUNCTION__ . ':'
//                                    . ' { ' . $xml . '}', CLogger::LEVEL_ERROR,
//                                    'b2b.ws');
                                //--------------------------------------------------
                                $error = false;
                            } else {
								
                                //--------------------------------------------------
                                Yii::log(__FILE__ . ':' . __LINE__ . ':'
                                    . __FUNCTION__ . ':'
                                    . ' { ' . $xml . '}', CLogger::LEVEL_ERROR,
                                    'b2b.ws');
                                //--------------------------------------------------
                                $strError = $response->ImportarXMLResult->any;
                                
                                //--------------------------------------------------
								$objectXml = simplexml_load_string($strError);
								if(isset($objectXml->NewDataSet->Table->f_detalle)){
									Yii::log(__FILE__ . ':' . __LINE__ . ':'
                                    . __FUNCTION__ . ':'
                                    . ' { ' . print_r($objectXml->NewDataSet->Table->f_detalle, true) 
									. '}', CLogger::LEVEL_ERROR,
                                    'b2b.ws');	
								}else{
									//--------------------------------------------------
									Yii::log(__FILE__ . ':' . __LINE__ . ':'
                                    . __FUNCTION__ . ':'
                                    . ' { ' . $strError . '}', CLogger::LEVEL_ERROR,
                                    'b2b.ws');
								}
                            }
                        }
                    }                    
                }                
            }            
        } catch(Exception $exc) {
            //----------------------------------------------------
            Yii::log(__FILE__ . ':' . __LINE__ . ':' . __FUNCTION__ . ':'
                . ' { ' . $exc->getMessage() . '}', CLogger::LEVEL_ERROR,
                'b2b.ws');
            //---------------------------------------------------            
        }
		//Seguimiento a consumo ws --------------------------------------------------
		$sql = "UPDATE time_wait_ws SET datetime_end='".date('Y-m-d H:i:s')."' WHERE data= ".$model->ord_id;
		Yii::app()->db->createCommand($sql)->execute();
		// --------------------------------------------------------------------------
        return (!$error) ? true : false;
    }

}

?>
