<?php

/**
 * This is the model class for table "b2b_parameter".
 *
 * The followings are the available columns in table 'b2b_parameter':
 * @property integer $id_para
 * @property string $clave
 * @property string $valor
 */
class Parameter extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'b2b_parameter';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('clave', 'length', 'max'=>250),
                        array('valor','numerical','integerOnly'=>true),
                        array('valor', 'required'),
                        array('valor','Validar0'),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('id_para, clave','safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id_para' => 'Id',
			'clave' => 'Clave',
			'valor' => 'Valor',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
    /**
     * Valida que el valor sea mayor a 0
     * 
     * @author Duvan Agudelo <John.agudelo@ingeneo.com.co>
     * @copyright 2015 INGENEO S.A.S.
     * @license http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version Release: $Id$
     * @return mixed
     */    
        
    public function Validar0($attribute, $params) {
        if ($this->attributes['valor'] > 0) {
            return $this->attributes['valor'];
        } else {
            $this->addError($attribute, 'Valor debe ser mayor a 0');
        }
    }

    public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('id_para',$this->id_para);
		$criteria->compare('clave',$this->clave,true);
		$criteria->compare('valor',$this->valor,true);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Parameter the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
