<?php

/**
 * TestWebServices.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * TestWebServices.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2013 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class TestWebServices extends PHPUnit_Framework_TestCase
{

    public $classFactoryOrder;

    /**
     * Constructor de la clase
     * 
     * @return void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2013 INGENEO S.A.S.     
     * @access public     
     */
    protected function setUp()
    {
        // Create the Array fixture.
        $this->classFactoryOrder = new FactoryOrder();
    }

    public function dataCreateBasicXML()
    {
        //Creacion de la cabecera ----------------------------------------------
        $header = new HeaderOrder();
        $header->numeroReg = '2'; //se contruye numero propio del pedido
        $header->tipoReg = '430';
        $header->subTipoReg = '00';
        $header->versionReg = '02';
        $header->cia = '1';
        $header->liquidaImpuesto = '1';
        $header->consecAutoReg = '1';
        $header->indContacto = '1';
        $header->idCo = '001'; // f201_id_co_factura con la tabla t201
        $header->idTipoDocto = 'PV'; //t144_mc_motivo_impto_asumido - f021_id
        $header->consecDocto = '1'; //PREGUNTAR por el momento colocaremos el id del pedido
        $header->idFecha = '20140123'; //Formatro AAAAMMDD
        $header->idClaseDocto = '502';
        $header->indEstado = '1'; //VERIFICAR APROBACION POR CARTERA
        $header->indBackOrder = '1';
        $header->idTerceroFact = '890900842'; //INDICE DEL NIT comfenalco
        $header->idSucursalFact = '148'; //INDICE DE LA SUCURSAL - C.C. F COMFENALCO ANTIOQUIA ASEO
        $header->idTerceroRem = '890900842'; //INDICE DE BD DEL NIT
        $header->idSucursalRem = '027'; //INDICE DE BD DE LA SUCURSAL - C.C.F COMFENALCO GUAYABAL W040801
        $header->idTipoCliFact = '';
        $header->idCoFact = '001'; // f201_id_co_factura con la tabla t201
        $header->fechaEntrega = '20140123'; //Formatro AAAAMMDD
        $header->numDiasEntrega = '4';
        $header->numDoctoReferencia = '';
        $header->referencia = ''; //ADICIONAMOS EL NUMERO DE B2B PARA RELACIONARLO 
        $header->idCargue = '';
        $header->idMonedaDocto = 'COP';
        $header->idMonedaConv = 'COP';
        $header->tasaConv = '1';
        $header->idMonedaLocal = 'COP';
        $header->tasaLocal = '1';
        $header->idConPago = '60D'; //f201_id_cond_pago
        $header->indImpresion = '0'; //no impreso
        $header->notas = 'prueba jdh'; //colocamos la fecha de entrega
        $header->idCliContado = ''; //va vacio
        $header->idPuntoEnvio = '000';//tabla t215_mm_puntos_envio_cliente
        $header->idTerceroVendedor = '';//vacio y trar el cliente a facturar
        $header->contacto = '';//el contacto ya esta definido
        $header->direccion1 = '';// toma del contacto
        $header->direccion2 = '';// toma del contacto
        $header->direccion3 = '';// toma del contacto
        $header->idPais = '';// toma del contacto
        $header->idDepto = '';// toma del contacto
        $header->idCiudad = '';// toma del contacto
        $header->idBarrio = '';// toma del contacto
        $header->telefono = '';// toma del contacto
        $header->codPostal = '';// toma del contacto
        $header->email = '';// toma del contacto
        $header->indDescuento = '0';

        // Creacio de los items ------------------------------------------------
        $arrayItems = new stdClass();
        $arrayItems->arrayItems = array();

        $item = new ItemOrder();
        $item->numeroReg = '3'; //Consecutivo del item
        $item->tipoReg = '431';
        $item->subtipoReg = '00';
        $item->versionReg = '02';
        $item->cia = '1'; // id de la compañia 
        $item->idCo = '001'; // f201_id_co_factura con la tabla t201
        $item->idTipoDocto = 'PV'; //t144_mc_motivo_impto_asumido - f021_id
        $item->r = '1'; //Identificador del encabezado
        $item->nroRegistro = '1'; //Cantidad de registros - numero de items
        $item->idItem = ''; //Id del item t120_mc_item columna f120_rowid;
        //$item->referenciaItem = '3908'; //Id de la referencia t120_mc_item columna f120_referencia
        $item->referenciaItem = '7332'; //ADICIONAMOS EL NUMERO DE B2B PARA RELACIONARLO Aromatica Jaibel Disfrut Limonaría-Limón
        $item->codigoBarras = '';
        $item->idExt1Detalle = '';
        $item->idExt2Detalle = '';
        $item->idBodega = '1'; //SE REQUIERE LA BODEGA SE SACA DE TABLAS
        $item->idConcepto = '501';
        $item->idMotivo = '1'; //SE REQUIERE EL MOTIVO SE SACA DE TABLAS
        $item->indObsequio = '0';
        $item->idCoMovto = '001'; //f201_id_co_factura
        $item->idUnMovto = '';
        $item->idCcostoMovto = '';
        $item->idProyecto = '';
        $item->fechaEntrega = '20140123'; //Formatro AAAAMMDD
        $item->numDiasEntrega = '4';
        $item->idListaPrecio = ''; //f201_id_lista_precio NO ES NECESARIO
        $item->idUnidadMedida = 'UNID'; //consulta unidad de medida
        $item->cantPedidaBase = '7'; //Cantidad pedida formato 000000000000000.0000
        $item->cant2pedida = '000000000000000.0000'; //formato 000000000000000.0000
        $item->precioUnitario = '0';
        $item->indImptoAsumido = '0';
        $item->notas = 'RV'; //se adiciona la fecha de entrga y si es remision<
        $item->detalle = '';
        $item->indBackorder = '5';
        $item->indPrecio = '0';

        $arrayItems->arrayItems[] = $item;
        return array(
            array($header, $arrayItems, true)
        );
    }

    /**
     * @dataProvider dataCreateBasicXML
     * @param type $object
     * @param type $result
     * @return type
     */
//    public function testCreateBasicXML($header, $arrayItems, $result)
//    {
//
//
//        /*
//         * Ejemplo para 
//         * nit: 890900842 -  C.C. F COMFENALCO ANTIOQUIA  
//         * sucursal: 132 - C.C F COMFENALCO ANTIOQUIA LA 65 W510601
//         */
//
//        /**
//         * idUnidad de medida
//         * SELECT f120_referencia, f126_precio, f126_id_unidad_medida
//          FROM t126_mc_items_precios
//          JOIN (
//          SELECT f126_rowid_item AS 'idItem', MAX(f126_fecha_ts_actualizacion) AS 'fecha'
//          FROM t126_mc_items_precios
//          GROUP BY f126_rowid_item) AS t ON t.idItem = f126_rowid_item AND t.fecha = f126_fecha_ts_actualizacion
//          JOIN t120_mc_items ON f126_rowid_item = f120_rowid
//          where f120_referencia = '3908'
//         */
//        /**
//         * SELECCIONAR EL PUNTO DE ENVIO
//         * select * from t215_mm_puntos_envio_cliente as pe 
//          join t200_mm_terceros as t on t.f200_rowid = pe.f215_rowid_tercero
//          where pe.f215_id_sucursal = 132 and t.f200_nit = '890900842'
//         */
//        $res = false;
//        $respose = $this->classFactoryOrder->createXML($header, $arrayItems);
//        if(is_string($respose)) {
//            $res = true;
//        }
//        $this->assertEquals(
//            $result, $res
//        );
//    }
    
    
    public function testCreateOrder(){
        $res = false;
        $respose = $this->classFactoryOrder->createOrder(199);
        if(is_object($respose)) {
            $res = true;
        }
        $this->assertEquals(
            true, $res
        );
    }

}

?>
