<?php
/* @var $this OrderController */
/* @var $model Order */
/* @var $form TbActiveForm */
/* @var $listBranch BranchOffice  */
Yii::app()->clientScript->registerCoreScript('jquery.ui');
?>

<div class="form">
    <?php
    $form = $this->beginWidget('bootstrap.widgets.TbActiveForm',
        array(
        'id' => 'createorder-form',
        // Please note: When you enable ajax validation, make sure the corresponding
        // controller action is handling ajax validation correctly.
        // There is a call to performAjaxValidation() commented in generated controller code.
        // See class documentation of CActiveForm for details on this.
        'enableAjaxValidation' => true,
    ));
    ?>
    <?php echo $form->errorSummary($model); ?>
    <?php $this->widget('bootstrap.widgets.TbAlert'); ?>

    <div id="div-error" style="display: none;">
        <a class="close" type="button" data-dismiss="alert" href="#">×</a>
    </div>

    <?php if(count($listClient) < 1 || count($listBranch) < 1): ?>    
        <div class="alert alert-block alert-error">
            El usuario no posee clientes o sucursales asociadas
        </div>
    <?php else: ?>    
        <p class="help-block">Los campos con <span class="required">*</span> son requeridos.</p>
        <table class="items table" >
            <tr>
                <td><h5>Objeto del pedido
                        <span class="required">*</span> :</h5></td>
                <td class="radioButton"><?php
                    echo $form->inlineRadioButtonList($model, 'ord_objOrder',
                        array(
                        $model::COD_FACTURACION => 'Facturación',
                        $model::COD_REMISION => 'Remisión'),
                        array(
                        ''
                        )
                    );
                    ?></td>
                <td><h5>Presupuesto:</h5></td>
                <td><h5 id="presupuesto"></h5></td>
                <td><h5>Acumulado:</h5></td>
                <td><h5 id="acumulado"></h5></td>
            </tr>
            <tr>
                <td><h5>Nit:</h5></td>
                <td><div id="nit"><?php echo $defaultClient ?></div></td>
                <td><h5>Cliente:</h5></td>
                <td><?php
                    echo CHtml::dropDownList('codClient', $defaultClient,
                        $listClient, array('style' => 'width: 400px'))
                    ?></td>    
                <td><h5>Número de la orden</h5></td>
                <td><?php
                    echo $form->textField($model, "ord_number")
                    ?></td>
            </tr>        
            <tr>
                <td><h5>Código sucursal:</h5></td>
                <td><div id="branch"><?php echo $defaultBranch; ?></div></td>
                <td><h5>Sucursal:</h5></td>
                <td><div id="dropBranch">
                    <?php
                        $this->widget('yiiwheels.widgets.select2.WhSelect2',
                            array(
                            'asDropDownList' => true,
                            'language' => 'es',
                            //'model' => $model,
                            //'attribute' => 'codeBranch',
                            'name' => 'codeBranch',
                            'data' => $listBranch,
                            'htmlOptions' => array(
                                //'multiple' => 'basic',
                                'id' => 'codeBranch',
                                'selected' => $defaultBranch
                            ),
                            'pluginOptions' => array(
                                //'placeholder' => 'Seleccione',
                                'minimumInputLength' => 3,
                                'width' => '400px',
                            //'tokenSeparators' => array(',', ' ')
                            ),
                        ));
                        ?>
                    </div></td>            
                <td><h5>Fecha entrega esperada
                        <span class="required">*</span> :</h5></td>
                <td><div id="date-label" style="display: none"></div>
                    <div id="date">
                        <div class="input-append">
                            <?php
                            $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                                array(
                                'value' => $model->ord_date,
                                'name' => 'Order[ord_date]',
                                'htmlOptions' => array(
                                    'placeholder' => 'Seleccione',
                                    'readonly' => 'readonly',
                                    'title' => Yii::app()->params['msgTooltipFecha']
                                //'id'=>'Order-ord-date'
                                ),
                                'pluginOptions' => array(
                                    'format' => 'yyyy-mm-dd',
                                    'language' => 'es',
                                    'dates' => 'es'
                                )
                            ));
                            ?>
                            <span class="add-on"><icon class="icon-calendar"></icon></span>
                        </div>
                    </div>
                </td>
            </tr> 
            <tr>
                <td><h5>Descripción: </h5></td>
                <td colspan="5">
                    <?php
                    echo $form->textArea($model, 'ord_description',
                        array(
                        'rows' => 1,
                        'class' => 'span12',
                        'maxlength' => 55
                        )
                    );
                    ?> 
                </td>
            </tr>
        </table>
        <div id="form-products"></div>    
        <div id="div-status"></div>
        <?php 
        $RolFranquicias = Yii::app()->params['RolFranquicias'];
        if(!Yii::app()->user->checkAccess($RolFranquicias)):
        ?>
        <div id="summary" class="well" style="width: 20%; display: none;">            
            <table class="table" >
                <tr>
                    <td><strong>Total Neto:</strong></td>
                    <td><div id="total_net"></div></td>
                </tr>                         
                <tr>
                    <td><strong>Total Descuento:</strong></td>
                    <td>0</td>
                </tr>                         
                <tr>
                    <td><strong>Total Iva:</strong></td>
                    <td><div id="total_iva"></div></td>
                </tr>                         
                <tr>
                    <td><strong>Total:</strong></td>
                    <td><div id="total"></div></td>
                </tr>                         
            </table>            
        </div>
        <?php endif; ?>

        <div id="buttom" class="form-actions">        
            <?php
            echo TbHtml::button('Liquidar',
                array(
                'color' => TbHtml::BUTTON_COLOR_PRIMARY,
                'size' => TbHtml::BUTTON_SIZE_DEFAULT,
                'onClick' => 'liquidar()',
                'title' => Yii::app()->params['msgTooltipLiquidar']
            ));
            ?>
            &nbsp;
            <?php
            echo TbHtml::button('Salir',
                array(
                'id' => 'button-exit',
                'color' => TbHtml::BUTTON_COLOR_DEFAULT,
                'size' => TbHtml::BUTTON_SIZE_DEFAULT,
                'onClick' => 'exitOrder()',
                'title' => Yii::app()->params['msgTooltipSalir']
            ));
            ?>         
        </div>

    <?php endif; ?>    
    <?php $this->endWidget(); ?>

</div><!-- form -->
<script type="text/javascript">

    $(document).ready(function() {
        $('#createorder-form').find("input[type='radio']:checked").removeAttr('checked');
        validateQuotaBranch('<?= CController::createUrl('order/validateQuotaBranch') ?>');
        validateBudget('<?= CController::createUrl('order/validateBudget') ?>');
        getProducts();
    });

    $('#codClient').change(
        function(event) {				
            changeBranch();
    });

    $('#codeBranch').change(
        function(event) {            
        validateBudget('<?= CController::createUrl('order/validateBudget') ?>');
        validateQuotaBranch('<?= CController::createUrl('order/validateQuotaBranch') ?>');         
        getProducts();
    });

    $('#linkFilterRef').click(function() {
        filter("filterRef", "reference");
        clearFilter("filterDesc");
    });

    $('#linkFilterDesc').click(function() {
        filter("filterDesc", "description");
        clearFilter("filterRef");
    });


    /**
     * Metodo para consultar las sucursales 
     * disponibles segun el nit
     * @returns {undefined}
     */
    function changeBranch() {        
        distractor.show();
        nit = $("#codClient").val();
        $("#nit").html(nit);
        $.ajax({url: '<?php echo CController::createUrl('order/getBranch') ?>',
            type: "post",
            data: {nit: nit},			
            success: function(data) {
                $("#dropBranch").html(data);				               
            },
            complete: function(){
                validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch') ?>');
                validateBudget('<?= CController::createUrl('order/validateBudget') ?>');
                getProducts();
            }});
    }

    /**
     * Metodo para traer los productos segun
     * el codigo de la sucursal y el nit
     * @returns {undefined}     
     * */
    function getProducts() {
        distractor.show();
        codeBranch = $("#codeBranch").val();
        $("#branch").html(codeBranch);
        $.ajax({url: '<?php echo CController::createUrl('order/getproducts') ?>',
            type: "post",
            data: {codeBranch: codeBranch,
                nit: $("#codClient").val()},
            //dataType: 'json',
            success: function(data) {
                $("#form-products").html(data);
                $('.amount').focus(function() {
                    defaultText = $(this).val();
                    $(this).val('');
                    string = $(this).attr('id');
                    stringSplit = string.split('_');
                    iden = stringSplit[2];
                    $('#' + iden + '_tr').attr('class', 'error');
                    $('#' + iden + '-sub').html(0);
                    $('#' + iden + '-sub-iva').html(0);
                    $('#' + iden + '_sub_input_id').val(0);
                });
                distractor.hide();
                //$('.amount').blur(function() {
                //$(this).val(defaultText);
                //});
            }});
    }


    function filterCatalogo(idFilter, classFilter) {
//$("#" + idFilter).blur(function() {
    distractor.show();
    var filter = $('#' + idFilter).val(), count = 0;
    //if (filter) {
        $("." + classFilter).each(function() {
            string = $(this).attr('id');
            stringSplit = string.split('_');
            iden = stringSplit[0];
            // If the list item does not contain the text phrase fade it out
            if ($(this).text().trim().search(new RegExp(filter, "i")) < 0) {
                $('#' + iden + '_tr').fadeOut();
                //$(this).fadeOut();
                // Show the list item if the phrase matches and increase the count by 1
            } else {
                $('#' + iden + '_tr').show();
                //$(this).show();
                count++;
            }
        });
        // Update the count
        //var numberItems = count;
        if (filter !== '') {
            $("#filter-count").html("&nbsp;<i>Registros encontrados: " + count + "</i>");
        } else {
            $("#filter-count").html("");
        }
    //}
    distractor.hide();
    //});
}


    /**
     * Metodo que permite realizar los calculos 
     * matematicos y valida la existencia del inventario
     * @param string id
     * @param string ident
     * @returns {Boolean}     
     * */
    function calculate(id, ident) {
        stringQuantity = $('#' + id).val();
        quantity = stringQuantity.replace(/[^0-9\.]/g, '');
        tempQuantity = parseInt(quantity);
        tempInvent = parseInt($('#' + ident + "_inv").val());
        invent = $('#' + ident + "_inv").val();
//        if (tempInvent < tempQuantity) {
//            alert('La cantidad solicitada es mayor al inventario existente');
//            $('#' + id).val(invent);
//            quantity = invent;
//        }
        priceUnt = $('#' + ident + "_unt_price").val();
        priceUntIva = $('#' + ident + "_unt_price_iva").val();
        valUnt = quantity * priceUnt;
        valUntIva = quantity * priceUntIva;
        //evita desborde de los precios
        if (valUnt.toString().length > 9 || valUntIva.toString().length > 9) {
            quantity = quantity.substr(0, 5);
            valUnt = quantity * priceUnt;
            valUntIva = quantity * priceUntIva;
            alert('Número muy extenso, por favor revise las cantidades');
        }
        //Senala los items con cantidades en cero o vacio
        if (quantity > 0) {
            $('#' + ident + '_tr').removeClass("error");
        } else {
            $('#' + ident + '_tr').attr('class', 'error');
        }
        //Sumatorias y formateo de resultados
        $('#' + id).val(quantity);
        $('#' + ident + '_amount_request').val(tempQuantity);
        $('#' + ident + '_amount_request').number(tempQuantity);
        $('#' + ident + '-sub').html(valUnt);
        $('#' + ident + '-sub').number(valUnt);
        $('#' + ident + '_sub_input_id').val(valUnt);
        $('#' + ident + '_sub_input_id').number(valUnt);
        $('#' + ident + '-sub-iva').html(valUntIva);
        $('#' + ident + '-sub-iva').number(valUntIva);
        return false;
    }
    
    /**
     * funcion al ejecutar el poton liquidar
     * @returns {undefined}
     */
    function liquidar() {
        distractor.show();
        //Inhabilitamso los filtros --------------------------------------------        
        $('#linkFilterRef').click(function() {
            return false;
        });
        $('#linkFilterDesc').click(function() {
            return false;
        });
        
        hideInputsEmpty();
        //Validaciones en servidor ---------------------------------------------       
        var form = jQuery('#createorder-form');
        $.ajax({
            type: 'POST',
            url: "<?php echo CController::createUrl('order/createorder'); ?>",
            data: form.serialize() + "&ajax=order-form",
            //dataType: 'json',
            success: function(data) {
                if (data != null && $.trim(data)) {
                    newData = data.replace('class="errorSummary"', '');
                    showError(newData);
					$('#createorder-form').find('input, textarea, select').removeAttr('disabled');
                    distractor.hide();
                    return false;
                }
                showError('');               
                hideTabs();                
                hideTr();                
                disabledinputs();
                summary();
                buttomSend('send', '<?php echo CController::createUrl('order/changebuttom') ?>');
                distractor.hide();
            },
            error: function(data) { // if error occured
                showError('A ocurrido un error, comuníquese con el administrador');
                distractor.show();
            },
        });
    }

    /**
     * Metodo para sacar la relacion 
     * de los calculos
     * @returns {undefined}     
     */
    function summary() {
        subUnt = sumaColumn('.sub');
        $('#total_net').html(subUnt);
        $('#total_net').number(subUnt);
        subUntIva = sumaColumn('.sub_iva');
        $('#total').html(subUntIva);
        $('#total').number(subUntIva);
        totalIva = subUntIva - subUnt;
        $('#total_iva').html(totalIva);
        $('#total_iva').number(totalIva);
        if(subUnt < <?= $model->getLimitOrder() ?>){
            showError('El pedido no supera el valor mínimo ($'
                    +'<?= number_format($model->getLimitOrder()) ?>'+').');
        }
    }


    /**
     * Funcion que permite desabilidar los campos
     * @returns {undefined}
     */
    function disabledinputs() {
        $('#filterRef').val('');
        $('#filterDesc').val('');
        $('#summary').show();
        date = $('#yw0').val();
        $('#date-label').html(date);
        $('#yw0_datetimepicker').hide();
        $('#date-label').show();
        $('#createorder-form').find('input, textarea, button, select').attr('disabled', 'disabled');
    }

    /**
     * Funcion para mostrar los tabs
     * @returns {undefined}          
     */
    function showTabs() {
        $('.ui-accordion-content').each(function() {
            head = $(this).prev('h3');
            head.show();
            //head.on();            
            //head.show().off().addClass('ui-state-active');
        });
        var options = {autoHeight: false, collapsible: false, active: false};
        $('#acordeon-in-on').accordion('destroy').accordion(options);
    }

    /**
     * Funcion que habilita la edicion de la informacion
     * @returns {undefined}     
     * */
    function edit() {
        showTabs();
        showTr();
        $('#summary').hide();
        $('#yw0_datetimepicker').show();
        $('#date-label').hide();
        $('#createorder-form').find('input, textarea, button, select').removeAttr('disabled');
        buttomSend('liquidar', '<?php echo CController::createUrl('order/changebuttom') ?>');
    }
    
    /**
     * Funcion para crear peticiones
     * @returns {undefined}
     */
    function newOrder() {
        showDistractor();
        inputStatus = '<?php echo CHtml::hiddenField('status', Order::ORDER_NEW) ?>';
        $('#div-status').html(inputStatus);
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }
    
    /**
     * Funcion para salir  
     * @returns {undefined}     
     */
    function exitOrder() {
        if (confirm('¿Desea salir de la creación de pedidos?. \n\
Recuerde que los cambios se perderán')) {
            showDistractor();
            var url = "<?php echo Yii::app()->createUrl('order/admin') ?>";
            $(location).attr('href', url);
        }
    }

    /**
     * Funcion que permite habilitar los campos 
     * para guardar la informacion
     * @returns {Boolean}
     */
    function save() {
        showDistractor();
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }
         
    /**
     * funcion para autorizar las peticiones
     * @returns {Boolean}
     */
    function allowOrder() {
        showDistractor();
        inputStatus = '<?php
    echo CHtml::hiddenField('status', Order::STATUS_ALLOW);
    ?>';
        $('#div-status').html(inputStatus);
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }  

    /**
     * funcion para solicitar autorizacion de las peticiones
     * @returns {Boolean}
     */
    function changetStatus() {
        showDistractor();
        inputStatus = '<?php
    echo CHtml::hiddenField('status', Order::STATUS_PENDING);
    ?>';
        $('#div-status').html(inputStatus);
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }
</script>