<?php
/* @var $this OrderController */
/* @var $model Order */
/* @var $form TbActiveForm */
/* @var $listBranch BranchOffice  */
Yii::app()->clientScript->registerCoreScript('jquery.ui');
//Yii::app()->clientScript->registerCoreScript('jquery.yii');
//Yii::app()->clientScript->registerCoreScript('jquery');
?>

<div class="form">

    <?php
    $form = $this->beginWidget('bootstrap.widgets.TbActiveForm',
        array(
        'id' => 'createorder-form',
        // Please note: When you enable ajax validation, make sure the corresponding
        // controller action is handling ajax validation correctly.
        // There is a call to performAjaxValidation() commented in generated controller code.
        // See class documentation of CActiveForm for details on this.
        'enableAjaxValidation' => false,
    ));
    ?>
    <?php echo $form->errorSummary($model); ?>
    <?php $this->widget('bootstrap.widgets.TbAlert'); ?>

    <div id="div-error" style="display: none;">
        <a class="close" type="button" data-dismiss="alert" href="#">×</a>
    </div>

    <?php if(count($listClient) < 1 || count($listBranch) < 1): ?>    
        <div class="alert alert-block alert-error">
            El usuario no posee clientes o sucursales asociadas
        </div>
    <?php else: ?>    
        <p class="help-block">Los campos con <span class="required">*</span> son requeridos.</p>
        <table class="items table" >
            <tr>
                <td><h5>Objeto del pedido
                        <span class="required">*</span> :</h5></td>
                <td class="radioButton"><?php
                    echo $form->inlineRadioButtonList($model, 'ord_objOrder',
                        array(
                        $model::COD_FACTURACION => 'Facturación',
                        $model::COD_REMISION => 'Remisión'),
                        array(
                        ''
                        )
                    );
                    ?></td>
                <td><h5>Presupuesto:</h5></td>
                <td><h5 id="presupuesto"></h5></td>
                <td><h5>Acumulado:</h5></td>
                <td><h5 id="acumulado"></h5></td>
            </tr>
            <tr>
                <td><h5>Nit:</h5></td>
                <td><div id="nit"><?php echo $defaultClient ?></div></td>
                <td><h5>Cliente:</h5></td>
                <td><?php
                    echo CHtml::dropDownList('codClient', $defaultClient,
                        $listClient, array('style' => 'width: 400px'))
                    ?></td>    
                <td><h5>Número de la orden</h5></td>
                <td><?php
                    echo $form->textField($model, "ord_number")
                    ?></td>
            </tr>        
            <tr>
                <td><h5>Código sucursal:</h5></td>
                <td><div id="branch"><?php echo $defaultBranch; ?></div></td>
                <td><h5>Sucursal:</h5></td>
                <td><div id="dropBranch">
                    <?php
                        $this->widget('yiiwheels.widgets.select2.WhSelect2',
                            array(
                            'asDropDownList' => true,
                            'language' => 'es',
                            //'model' => $model,
                            //'attribute' => 'codeBranch',
                            'name' => 'codeBranch',
                            'data' => $listBranch,
                            'htmlOptions' => array(
                                //'multiple' => 'basic',
                                'id' => 'codeBranch',
                                'selected' => $defaultBranch
                            ),
                            'pluginOptions' => array(
                                //'placeholder' => 'Seleccione',
                                'minimumInputLength' => 3,
                                'width' => '400px',
                            //'tokenSeparators' => array(',', ' ')
                            ),
                        ));
                        ?>
                    </div></td>            
                <td><h5>Fecha entrega esperada
                        <span class="required">*</span> :</h5></td>
                <td><div id="date-label" style="display: none"></div>
                    <div id="date">
                        <div class="input-append">
                            <?php
                            $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                                array(
                                'value' => $model->ord_date,
                                'name' => 'Order[ord_date]',
                                'htmlOptions' => array(
                                    'placeholder' => 'Seleccione',
                                    'readonly' => 'readonly',
                                    'title' => Yii::app()->params['msgTooltipFecha']
                                //'id'=>'Order-ord-date'
                                ),
                                'pluginOptions' => array(
                                    'format' => 'yyyy-mm-dd',
                                    'language' => 'es',
                                    'dates' => 'es'
                                )
                            ));
                            ?>
                            <span class="add-on"><icon class="icon-calendar"></icon></span>
                        </div>
                    </div>
                </td>
            </tr> 
            <tr>
                <td><h5>Descripción: </h5></td>
                <td colspan="5">
                    <?php
                    echo $form->textArea($model, 'ord_description',
                        array(
                        'rows' => 1,
                        'class' => 'span12',
                        'maxlength' => 55
                        )
                    );
                    ?> 
                </td>
            </tr>
        </table>
        <!--BUSQUEDA DE ITEMS-->
        <div class="well">            
            <table>
                <tr>
                    <td><strong>Referencia</strong>
                        <br/>
                        <div><?php
                            echo TbHtml::telField("filterRef", '',
                                array(
                                'size' => 10,
                                'onBlur' => 'js:filter("filterRef", "reference");'
                                . 'clearFilter("filterDesc")'
                            ));
                            echo TbHtml::link(TbHtml::icon(TbHtml::ICON_FILTER),
                                'javascript:void(0)',
                                array(
                                'id' => 'linkFilterRef',
                            ));
                            ?></div>
                    </td>
                    <td><div><strong>Descripción item</strong></div>
                        <div>
                            <?php
                            echo TbHtml::telField("filterDesc", '',
                                array(
                                'size' => 10,
                                'onBlur' => 'js:filter("filterDesc", "description");'
                                . 'clearFilter("filterRef")'
                            ));
                            echo TbHtml::link(TbHtml::icon(TbHtml::ICON_FILTER),
                                'javascript:void(0)',
                                array(
                                'id' => 'linkFilterDesc',
                            ));
                            ?>
                        </div></td>
                    <td id="filter-count"></td>
                </tr>
            </table>
            <div id="form-products"></div>
        </div>
        <!--FINALIZA BUSQUEDA ITEMS-->
        <legend>Items seleccionados</legend>
        <div id="item-selected">
            <table id="table-selected" class="items table" >
                <thead>
                    <tr>
                        <th>Categoría</th>
                        <th>Referencia</th>
                        <th>Descripción item</th>
                        <th>Cantidades</th>
                        <th>Precio unt</th>
                        <th>Subtotal unt</th>
                        <th>Iva</th>                                
                        <th>Precio unt con iva</th>                                
                        <th>Subtotal con iva</th>
                        <th>Variación de la cantidad</th>                                
                        <th>Consumo promedio</th>
                        <th class="accion">Acción</th>                                
                    </tr>
                </thead>
                <tbody>                    
                </tbody>
            </table>
            <div id="count-items-selected"></div>
            <br/>
        </div>

        <div id="div-status"></div>    
        <div><?php echo CHtml::hiddenField('type',
                            'ref'); ?></div>    

        <div id="summary" class="well" style="width: 20%; display: none;">
            <table class="table" >
                <tr>
                    <td><strong>Total Neto:</strong></td>
                    <td><div id="total_net"></div></td>
                </tr>                         
                <tr>
                    <td><strong>Total Descuento:</strong></td>
                    <td>0</td>
                </tr>                         
                <tr>
                    <td><strong>Total Iva:</strong></td>
                    <td><div id="total_iva"></div></td>
                </tr>                         
                <tr>
                    <td><strong>Total:</strong></td>
                    <td><div id="total"></div></td>
                </tr>                         
            </table>
        </div>

        <div id="buttom" class="form-actions">        
            <?php
            echo TbHtml::button('Liquidar',
                array(
                'color' => TbHtml::BUTTON_COLOR_PRIMARY,
                'size' => TbHtml::BUTTON_SIZE_DEFAULT,
                'onClick' => 'liquidar()',
                'title' => Yii::app()->params['msgTooltipLiquidar']
            ));
            ?>
            &nbsp;
            <?php
            echo TbHtml::button('Salir',
                array(
                'id' => 'button-exit',
                'color' => TbHtml::BUTTON_COLOR_DEFAULT,
                'size' => TbHtml::BUTTON_SIZE_DEFAULT,
                'onClick' => 'exitOrder()',
                'title' => Yii::app()->params['msgTooltipSalir']
            ));
            ?>         
        </div>

    <?php endif; ?>    
<?php $this->endWidget(); ?>

</div><!-- form -->
<script type="text/javascript">

    $(document).ready(function() {
        validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch') ?>');
        $('#createorder-form').find("input[type='radio']:checked").removeAttr('checked');
        validateBudget('<?= CController::createUrl('order/validateBudget') ?>');
        getProducts();
        countItemsSelected(false);
    });
    $('#codClient').change(function(event) {
		distractor.show();
		changeBranch();
    });
    $('#codeBranch').change(function(event) {
        validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch') ?>');
        validateBudget('<?= CController::createUrl('order/validateBudget') ?>');
        getProducts();
    });
    $('#linkFilterRef').click(function() {
        filter("filterRef", "reference");
        clearFilter("filterDesc");
    });
    $('#linkFilterDesc').click(function() {
        filter("filterDesc", "description");
        clearFilter("filterRef");
    });

    /**
     * Metodo para consultar las sucursales 
     * disponibles segun el nit
     * @returns {undefined}
     */
    function changeBranch() {	
		distractor.show();
        nit = $("#codClient").val();
        $("#nit").html(nit);
        $.ajax({url: '<?php echo CController::createUrl('order/getBranch') ?>',
            type: "post",
            data: {nit: nit},
			//async: false,
            success: function(data) {				
                $("#dropBranch").html(data);
            },
            complete: function(){
                validateQuotaBranch('<?php echo CController::createUrl('order/validateQuotaBranch') ?>');
                validateBudget('<?= CController::createUrl('order/validateBudget') ?>');
                getProducts();
        },});
    }

    /**
     * Metodo para traer los productos segun
     * el codigo de la sucursal y el nit
     * @returns {undefined}     
     * */
    function getProducts() {
        distractor.show();
        $("#table-selected > tbody").html('');
        $('#filterRef').val('');
        $('#filterDesc').val('');
        $("#filter-count").html('');
        countItemsSelected(false);
        codeBranch = $("#codeBranch").val();
        $("#branch").html(codeBranch);
        $.ajax({url: '<?php echo CController::createUrl('order/getproducts') ?>',
            type: "post",
            data: {codeBranch: codeBranch,
                nit: $("#codClient").val(), type: "ref"},
			async: false,
            success: function(data) {
                $("#form-products").html(data);
                distractor.hide();
                //$('.amount').blur(function() {
                //$(this).val(defaultText);
                //});
            }});
    }

    /**
     * Metodo que permite realizar los calculos 
     * matematicos y valida la existencia del inventario
     * @param string id
     * @param string ident
     * @returns {Boolean}     
     * */
    function calculate(id, ident) {
        stringQuantity = $('#' + id).val();
        quantity = stringQuantity.replace(/[^0-9\.]/g, '');
        tempQuantity = parseInt(quantity);
        tempInvent = parseInt($('#' + ident + "_inv").val());
        invent = $('#' + ident + "_inv").val();
//        if (tempInvent < tempQuantity) {
//            alert('La cantidad solicitada es mayor al inventario existente');
//            $('#' + id).val(invent);
//            quantity = invent;
//        }
        priceUnt = $('#' + ident + "_unt_price").val();
        priceUntIva = $('#' + ident + "_unt_price_iva").val();
        valUnt = quantity * priceUnt;
        valUntIva = quantity * priceUntIva;
        //evita desborde de los precios
        if (valUnt.toString().length > 9 || valUntIva.toString().length > 9) {
            quantity = quantity.substr(0, 5);
            valUnt = quantity * priceUnt;
            valUntIva = quantity * priceUntIva;
            alert('Número muy extenso, por favor revise las cantidades');
        }
        //Senala los items con cantidades en cero o vacio
        if (quantity > 0) {
            $('#' + ident + '_tr').removeClass("error");
        } else {
            $('#' + ident + '_tr').attr('class', 'error');
        }
        //Sumatorias y formateo de resultados
        $('#' + id).val(quantity);
        $('#' + ident + '_amount_request').val(tempQuantity);
        $('#' + ident + '_amount_request').number(tempQuantity);
        $('#' + ident + '-sub').html(valUnt);
        $('#' + ident + '-sub').number(valUnt);
        $('#' + ident + '_sub_input_id').val(valUnt);
        $('#' + ident + '_sub_input_id').number(valUnt);
        $('#' + ident + '-sub-iva').html(valUntIva);
        $('#' + ident + '-sub-iva').number(valUntIva);
        return false;
    }

    /**
     * funcion al ejecutar el poton liquidar
     * @returns {undefined}
     */
    function liquidar() {
        distractor.show();
        //Inhabilitamso los filtros --------------------------------------------        
        $('#linkFilterRef').click(function() {
            return false;
        });
        $('#linkFilterDesc').click(function() {
            return false;
        });
        hideInputsEmpty();
        //Validaciones en servidor ---------------------------------------------       
        var form = jQuery('#createorder-form');
        $.ajax({
            type: 'POST',
            url: "<?php echo CController::createUrl('order/createorder'); ?>",
            data: form.serialize() + "&ajax=order-form",
            //dataType: 'json',
            success: function(data) {
                if (data != null && $.trim(data)) {
                    newData = data.replace('class="errorSummary"', '');
                    showError(newData);
                    distractor.hide();
                    $('#createorder-form').find('input').removeAttr('disabled');
                    return false;
                }
                showError('');
                //Deshabilitar inputs ------------------------------------------
                hideTr();
                disabledinputs();
                summary();
                countItemsSelected(true);
                buttomSend('send', '<?php echo CController::createUrl('order/changebuttom') ?>');
                distractor.hide();
            },
            error: function(data) { // if error occured
                showError('A ocurrido un error, comuníquese con el administrador');
                distractor.hide();
            }
        });
    }

    /**
     * Funcion que permite desabilidar los campos
     * @returns {undefined}
     */
    function disabledinputs() {
        $('#filterRef').val('');
        $('#filterDesc').val('');
        $("#filter-count").html('');
        $('#summary').show();
        $('#tr_head').hide();
        $('.accion').hide();
        date = $('#yw0').val();
        $('#date-label').html(date);
        $('#yw0_datetimepicker').hide();
        $('#date-label').show();
        $('#createorder-form').find('input, textarea, button, select').attr('disabled', 'disabled');
    }    

    /**
     * Funcion que habilita la edicion de la informacion
     * @returns {undefined}     
     * */
    function edit() {
        showTrRef();
        $('.accion').show();
        $('#summary').hide();
        $("#filter-count").html('');
        $('#yw0_datetimepicker').show();
        $('#date-label').hide();
        $('#createorder-form').find('input, textarea, button, select').removeAttr('disabled');
        buttomSend('liquidar', '<?php echo CController::createUrl('order/changebuttom') ?>');
    }    

    /**
     * Funcion para crear peticiones
     * @returns {undefined}
     */
    function newOrder() {
        showDistractor();
        inputStatus = '<?php echo CHtml::hiddenField('status',
    Order::ORDER_NEW) ?>';
        $('#div-status').html(inputStatus);
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }

    /**
     * Funcion para salir  
     * @returns {undefined}     
     */
    function exitOrder() {
        if (confirm('¿Desea salir de la creación de pedidos?. \n\
Recuerde que los cambios se perderán')) {
            showDistractor();
            var url = "<?php echo Yii::app()->createUrl('order/admin') ?>";
            $(location).attr('href', url);
        }
    }

    /**
     * Funcion que permite habilitar los campos 
     * para guardar la informacion
     * @returns {Boolean}
     */
    function save() { 
        showDistractor();
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }    

    /**
     * funcion para autorizar las peticiones
     * @returns {Boolean}
     */
    function allowOrder() {   
        showDistractor();
        inputStatus = '<?php
    echo CHtml::hiddenField('status', Order::STATUS_ALLOW);
    ?>';
        $('#div-status').html(inputStatus);
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }  

    /**
     * funcion para solicitar autorizacion de las peticiones
     * @returns {Boolean}
     */
    function changetStatus() {   
        showDistractor();
        inputStatus = '<?php
    echo CHtml::hiddenField('status', Order::STATUS_PENDING);
    ?>';
        $('#div-status').html(inputStatus);
        enabledForm('createorder-form');
        hideInputsEmpty();
        submitForm('createorder-form');
    }

</script>