<?php
/* @var $this OrderController */
/* @var $model Order */


$this->breadcrumbs = array(
    'Pedidos' => array('index'),
    'Administrar Pedidos',
);




$this->menu = array(
//    array('label' => 'Crear Pedido Catálogo', 'url' => array('createorder')), 
//    array('label' => 'Crear Pedido Referencia', 'url' => array('createorder', 'type'=>'ref')),
//    array('label' => 'Cargar Pedido', 'url' => array('loadfile')),        
);

if(Yii::app()->user->checkAccess('OrderCreateorder')){
    $this->menu[] = array('label' => 'Crear Pedido Catálogo', 'url' => array('createorder'));
    $this->menu[] = array('label' => 'Crear Pedido Referencia', 'url' => array('createorder', 'type'=>'ref'));
}

if(Yii::app()->user->checkAccess('OrderLoadfile')){
    $this->menu[] = array('label' => 'Cargar Pedido', 'url' => array('loadfile'));
}

if(Yii::app()->user->checkAccess('OrderLoadfilemultibranch')){
    $this->menu[] = array('label' => 'Cargar pedido sucursales', 'url' => array('loadfilemultibranch'));
}

if(Yii::app()->user->checkAccess('OrderCreateordersales')){
    $this->menu[] = array('label' => 'Crear Pedido Catálogo vendedor', 'url' => array('createordersales'));
}

if(Yii::app()->user->checkAccess('OrderLoadfilesales')){
    $this->menu[] = array('label' => 'Cargar Pedido Vendedor', 'url' => array('loadfilesales'));
}



Yii::app()->clientScript->registerScript('search',
    "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$('#order-grid').yiiGridView('update', {
		data: $(this).serialize()
	});
	return false;
});
");
?>

<h3>Administrar Pedidos</h3>

<?php $this->widget('bootstrap.widgets.TbAlert'); ?>

<?php echo CHtml::link('Búsqueda Avanzada',
    '#', array('class' => 'search-button btn'));
?>
<div class="search-form" style="display:none">
    <?php
    $this->renderPartial('_search', array(
        'model' => $model,
    ));
    ?>
</div><!-- search-form -->

<?php

$this->widget('bootstrap.widgets.TbGridView',
    array(
    'type' => 'striped condensed',
    //'template' => "{items}",
    'id' => 'order-grid',
    'dataProvider' => $model->search(),
    'filter' => $model,
    'columns' => array(
        //'ord_id',
        array(
            'name' => 'ord_id',
            'value' => '$data->validateLinkLiq($data->ord_id, $data->ord_status)',
            'type' => 'html',
        ),
        'ord_nit',
        array(
            'name' => 'ord_nameClient',
            'filter' => false,
            'value' => '$data->getNameClient($data->ord_nit)'
        ),
        'ord_codeBranch',
        array(
            'filter' => false,
            'name' => 'ord_nameBranch',
            'value' => '$data->getNameBranch($data->ord_nit, $data->ord_codeBranch)'
        ),
        'ord_number',
        //'ord_status',
        array(
            'name' => 'ord_status',
            'filter' => $model->listStatus(),
            //'type' => 'html',
            'value' => '$data->ord_status',
            'htmlOptions' => array('nowrap' => 'true', 'width' => '8%'),

        ),
        'ord_date',
        'ord_user',
        //'ord_total_net',
        /*
          'ord_total_discount',
          'ord_total_iva',
          'ord_total',
          'ord_nit',
         */
        array(
            'class' => 'bootstrap.widgets.TbButtonColumn',
            'header' => 'Acciones',
            'template' => '{view}{delete}',
            'deleteConfirmation' => '¿Desea eliminar éste pedido?',
            'buttons' => array(
                'delete' => array(
                    'visible' => '$data->validateDelete($data->ord_status)'
                ),
            )
        ),
    ),
));
?>
