<style>
    .wh-relational-column1, .wh-relational-column2{
        cursor: pointer;
        border-bottom: 1px dotted #000;
    }  
	
	.wh-relational-column1:hover, .wh-relational-column2:hover{
        font-weight: bold;        
    }
</style>

<?php
/* @var $this ReportController */

$this->breadcrumbs = array(
    'Reporte' => array('/report/orderapprove'),
    'Pedidos Aprobados',
);
Yii::app()->clientScript->registerCoreScript('jquery');
Yii::app()->clientScript->registerCoreScript('jquery.yiigridview');
Yii::app()->clientScript->registerCoreScript('jquery-ui.min');
//Yii::app()->clientScript->scriptMap['jquery-ui.min.js'] = true;
//Yii::app()->clientScript->scriptMap['jquery.yiigridview.js'] = true;
//Yii::app()->clientScript->scriptMap['*.js'] = true;
?>
<h2>Reporte - Pedidos Aprobados</h2>

<div class="form">
    <?php
    $form = $this->beginWidget('bootstrap.widgets.TbActiveForm',
        array(
        'id' => 'reportStatusOrder',
        'enableAjaxValidation' => false,
    ));
    ?>
	
	<?php $this->widget('bootstrap.widgets.TbAlert'); ?>
	
    <?php if(count($listClient) < 1 || count($listBranch) < 1): ?>    
        <div class="alert alert-block alert-error">
            El usuario no posee clientes o sucursales asociadas
        </div>
    <?php else: ?> 
        <table class="items table" >
            <tr>
                <td><h5>Fecha Inicial: </h5></td>
                <td><div class="input-append">
                        <?php
                        $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                            array(
                            'value' => $startDate,
                            'name' => 'start_date',
                            'htmlOptions' => array(
                                'placeholder' => 'Seleccione',
                                'readonly' => 'readonly',
								//'id'=>'Order-ord-date'
                            ),
                            'pluginOptions' => array(
                                'format' => 'yyyy-mm-dd',
                                'language' => 'es',
                                'dates' => 'es',
				'startDate' => '-'.Yii::app()->params['report']['startMonth'].'m',
				'endDate' => "+Infinity",
                           ),							
                        ));
                        ?>
                        <span class="add-on">
							<i class="icon-calendar"></i>
						</span>
                    </div>                
                </td>
                <td><h5>Fecha Final: </h5></td>
                <td><div class="input-append">
                        <?php
                        $this->widget('yiiwheels.widgets.datepicker.WhDatePicker',
                            array(
                            'value' => $endDate,
                            'name' => 'end_date',
                            'htmlOptions' => array(
                                'placeholder' => 'Seleccione',
                                'readonly' => 'readonly',
                            //'id'=>'Order-ord-date'
                            ),
                            'pluginOptions' => array(
                                'format' => 'yyyy-mm-dd',
                                'language' => 'es',
                                'dates' => 'es',
								'startDate' => '-'.Yii::app()->params['report']['startMonth'].'m',
								'endDate' => "+Infinity",
                            )
                        ));
                        ?>
                        <span class="add-on">
                            <icon class="icon-calendar"></icon></span>
                    </div>                
                </td>
            </tr>
            <tr>
                <td><h5>Cliente:</h5></td>
                <td><?php
                    echo CHtml::dropDownList('codClient', $defaultClient,
                        $listClient, array('style' => 'width: 400px'))
                    ?></td>        
                <td><h5>Sucursal:</h5></td>
                <td><div id="dropBranch">
                        <?php
                        $this->widget('yiiwheels.widgets.select2.WhSelect2',
                            array(
                            'asDropDownList' => true,
                            'language' => 'es',
                            //'model' => $model,
                            //'attribute' => 'codeBranch',
                            'name' => 'codeBranch',
                            'data' => $listBranch,
                            'htmlOptions' => array(
                                //'multiple' => 'basic',
                                'id' => 'codeBranch',
                                'selected' => $defaultBranch
                            ),
                            'pluginOptions' => array(
                                //'placeholder' => 'Seleccione',
                                'minimumInputLength' => 3,
                                'width' => '85%',
                            //'tokenSeparators' => array(',', ' ')
                            ),
                        ));
                        ?>
                    </div></td> 
            </tr>
        </table>
        <?php
        echo TbHtml::submitButton('Buscar',
            array(
            'id' => 'button-search',
            'color' => TbHtml::BUTTON_COLOR_PRIMARY,
            'size' => TbHtml::BUTTON_SIZE_DEFAULT,
            //'onClick' => 'search()',
        ));
        ?>
        <br/>
        <div id="result"></div>        
        <legend>Mis Pedidos Aprobados</legend>
        <?php
        $this->widget('yiiwheels.widgets.grid.WhGridView',
            array(
            'id' => 'myorders',
            'type' => 'striped bordered',
            'dataProvider' => $model->search(),
            'fixedHeader' => true,
            //'template' => "{items}",
            'columns' => array_merge(array(
                array(
                    'class' => 'yiiwheels.widgets.grid.WhRelationalColumn',
                    'name' => 'ord_id',
                    'url' => $this->createUrl('report/getdetailtrans'),
                    'value' => '$data->ord_id',
//                    'afterAjaxUpdate' => 'js:function(tr,rowid,data){
//bootbox.alert("I have afterAjax events too!<br/>This will only happen once for row with id: "+rowid);
//}'
                )
                ),
                array(
                'ord_nit',
                'ord_codeBranch',
                array(
                    'name' => 'ord_status',
                    'filter' => $model->listStatus(),
                    //'type' => 'html',
                    'value' => '$data->ord_status',
                ),
                'ord_date',
                'ord_user',
            )),
        ));
        ?>


    <?php endif; ?> 
    <?php $this->endWidget(); ?>
</div><!-- form -->

<script type="text/javascript">
    /**
     * Cambios de cliente
     */
    $('#codClient').change(
            function(event) {
                changeBranch();
            });

    /**
     * Metodo para consultar las sucursales 
     * disponibles segun el nit
     * @returns {undefined}
     */
    function changeBranch() {
		distractor.show();
        nit = $("#codClient").val();
        $('#button-search').attr('disabled', 'disabled');
        $("#nit").html(nit);
        $.ajax({url: '<?php echo CController::createUrl('report/getBranch') ?>',
            type: "post",
            data: {nit: nit},
            success: function(data) {
                $("#dropBranch").html(data);
                $('#button-search').removeAttr('disabled');
				distractor.hide();
            }});
    }

</script>

