<?php
/* @var $this UserController */
/* @var $model User */

$this->breadcrumbs=array(
	'Usuarios'=>array('index'),
	'Admministrar',
);

$this->menu=array(
	array('label'=>'Listar Usuarios', 'url'=>array('index')),
	array('label'=>'Crear Usuarios', 'url'=>array('create')),
);

Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$('#user-grid').yiiGridView('update', {
		data: $(this).serialize()
	});
	return false;
});
");
?>

<h3>Administrar Usuarios</h3>

<!--<p>
You may optionally enter a comparison operator (<b>&lt;</b>, <b>&lt;=</b>, <b>&gt;</b>, <b>&gt;=</b>, <b>&lt;&gt;</b>
or <b>=</b>) at the beginning of each of your search values to specify how the comparison should be done.
</p>-->

<?php echo CHtml::link('Búsqueda avanzada','#',array('class'=>'search-button btn')); ?>
&nbsp;
<?php echo TbHtml::button('Activar Usuarios',array(
        'id' => 'button-active',
        'color' => TbHtml::BUTTON_COLOR_PRIMARY,
        'size' => TbHtml::BUTTON_SIZE_DEFAULT,        
        'onClick' => 'activeUsers()',
        'title'=>'Activa los usuarios seleccinados'
    )); ?>
&nbsp;
<?php echo TbHtml::button('Inactivar Usuarios',array(
        'id' => 'button-inactive',
        'color' => TbHtml::BUTTON_COLOR_DANGER,
        'size' => TbHtml::BUTTON_SIZE_DEFAULT,        
        'onClick' => 'inactiveUsers()',
        'title'=>'Inactiva los usuarios seleccionados'
    )); ?>
<div class="search-form" style="display:none">
<?php $this->renderPartial('_search',array(
	'model'=>$model,
        'client' => $client,
        'clientSiesa' => $clientSiesa,
)); ?>
</div><!-- search-form -->

<?php 
//$this->widget('zii.widgets.grid.CGridView', array(
$this->widget('bootstrap.widgets.TbGridView', array(
	'id'=>'user-grid',
	'dataProvider'=>$model->search($client),
	'filter'=>$model,
	'columns'=>array(
		//'usr_user_ID',
		'usr_username',
		'usr_email',
        array(
            'filter'=>$model->arrayAllowEmail(),
            'name' => 'usr_allowNotify',
            'value' => '$data->getAllowEmail($data->usr_allowNotify)',
        ),
        array(
            'filter'=>$model->arrayStatus(),
            'name' => 'usr_status',
            'value' => '$data->getStatus($data->usr_status)',
        ),
        array(
            'filter'=>false,
            'type' => 'raw',
            'name' => 'check',
            'value' => function($data){
                return CHtml::checkBox('User['.$data->usr_user_ID.'][check]',false,
                        array(
                            'id'=>$data->usr_user_ID,
                            'class'=>'check-status'
                            ));
                },
        ),                
        array(
            //'class'=>'CButtonColumn',
            'class'=>'bootstrap.widgets.TbButtonColumn',
            'htmlOptions'=>array('style'=>'width: 50px')
		),
	),
)); ?>


<script type="text/javascript">
    function activeUsers(){
        distractor.show();
        var selected = [];
        $('.check-status').each(function() {
           if ($(this).is(':checked')) {
               selected.push($(this).attr('id'));
           }
        });
        $.ajax({url: '<?php echo CController::createUrl('user/activeusers') ?>',
            type: "post",
            data: {selected: selected},			
            success: function(data) {
                $('#user-grid').yiiGridView('update', {
                        data: $(this).serialize()
                });
                distractor.hide();
            }
        });
    }
    
    function inactiveUsers(){
        distractor.show();
        var selected = [];
        $('.check-status').each(function() {
           if ($(this).is(':checked')) {
               selected.push($(this).attr('id'));
           }
        });
        $.ajax({url: '<?php echo CController::createUrl('user/inactiveusers') ?>',
            type: "post",
            data: {selected: selected},			
            success: function(data) {
                $('#user-grid').yiiGridView('update', {
                        data: $(this).serialize()
                });
                distractor.hide();
            }
        });
    }
</script>


